#> snc:entity/ticks
# Manages entities functions in every tick
#
# @input
#   Any entity
#
# @output
#   Behavior for each entity

# Disable mobs
function snc:entity/disable_mobs

## This first section handle almost everything related with players and shifters
## For this datapack, villagers are almost the same as a player
# Delte barrier blocks (DANGER)
execute as @s[type=player,tag=!barrier] unless entity @a[distance=1..7.5,tag=transform] rotated ~ 0 run fill ^-5 ^-4 ^-5 ^5 ^3 ^5 minecraft:air replace barrier
tag @s remove barrier

## Select Shifter functions
execute if score @s shifter_vars matches 1.. run function snc:shifters/select_cool

# If player
execute as @s[type=player] run function snc:selectors/players_ticks

# Villager
execute as @s[tag=eldian] run function snc:eldian/main
execute as @s[tag=village] run function snc:eldian/village
execute as @s[tag=marleyan] run function snc:marleyan/select_marleyan

# If titan
execute as @s[type=!player,tag=titan] run function snc:titans/select_part

# If shifter
execute as @s[tag=shifter,type=!player,type=!villager] run function snc:shifters/select_dead

# Kill unless is a titan or a villager
execute as @s[type=zombie_villager,tag=!titan,tag=!head] run function snc:controller/kill_mob

execute as @s[type=area_effect_cloud] run function snc:player/gun/flare/select_color

## This second part handle pure titans

execute as @s[type=pig] run function snc:titans/trigger

# push back
execute if score @s push_back matches 0.. run function snc:controller/push_back

# animate hurt
execute if entity @s[type=!bat] if predicate snc:is_hurt if entity @s[tag=!killed] run particle minecraft:block minecraft:redstone_block ^ ^1 ^-.45 0 0 0 1 30

## Interact with stuff
execute as @s[type=interaction] run function snc:interact/main

# Set Motion to not moving projectiles
execute as @s[tag=not_mov] rotated as @p run function snc:controller/apply_motion/select_motion
# Projectile Effects
execute as @s[tag=projectile] run function snc:player/gun/select_effect
# Bullet Effects (If has bullet Ex: Spears, Canons, etc...)
execute as @s[tag=bullet] run function snc:player/gun/select_bullet

# Tp ropse to hooks
execute as @s[tag=rope,tag=R,tag=!buried] run tp @s @e[tag=hook,tag=R,sort=nearest,limit=1]
execute as @s[tag=rope,tag=L,tag=!buried] run tp @s @e[tag=hook,tag=L,sort=nearest,limit=1]

# Detect ODM landed
execute as @s[tag=hook,tag=R] unless predicate snc:is_riding_projectile run function snc:player/odm/ground/main
execute as @s[tag=hook,tag=L] unless predicate snc:is_riding_projectile run function snc:player/odm/ground/main

execute if score @s[tag=shooter,tag=R] id_shooter_R = @p id_player at @p rotated ~ 0 run tp @s ^-.3 ^.5 ^
execute if score @s[tag=shooter,tag=L] id_shooter_L = @p id_player at @p rotated ~ 0 run tp @s ^.3 ^.5 ^

#Detect Item
execute as @s[type=falling_block,tag=debris] run function snc:item/debris/main